config/routes.rb
RailsBpm::Engine.routes.draw do

  root 'dashboard#index'

  resources :process_definitions
  resources :task_definitions
  resources :roles
  resources :users, only: [ :index, :edit, :update ]

end

app/models/concerns/rails_bpm/has_bpm_roles.rb
module RailsBpm
  module HasBpmRoles
    extend ActiveSupport::Concern

    included do
      has_many :rails_bpm_user_roles, class_name: RailsBpm::UserRole.name
      has_many :rails_bpm_roles, through: :rails_bpm_user_roles
    end

    def bpm_roles
      self.rails_bpm_roles
    end
  end
end

app/models/rails_bpm/process_definition.rb
module RailsBpm
  class ProcessDefinition < ActiveRecord::Base
    audited
  end
end

app/models/rails_bpm/role.rb
module RailsBpm
  class Role < ActiveRecord::Base
    validates :name, presence: true, uniqueness: true

    has_many :rails_bpm_user_roles, class_name: RailsBpm::UserRole.name, foreign_key: :rails_bpm_role_id
    has_many :users, through: :rails_bpm_user_roles, class_name: RailsBpm.user_class_name
  end
end

app/models/rails_bpm/user_role.rb
module RailsBpm
  class UserRole < ActiveRecord::Base
    belongs_to :user, class_name: RailsBpm.user_class_name, foreign_key: :user_id
    belongs_to :rails_bpm_role, class_name: RailsBpm::Role.name, foreign_key: :rails_bpm_role_id
  end
end

app/controllers/rails_bpm/application_controller.rb
module RailsBpm
  class ApplicationController < ActionController::Base

    def extract_errors(entity)
      errors = []
      entity.errors.each do |k,v|
        errors << "#{k.to_s.humanize} #{v}."
      end
      errors
    end

  end
end

app/controllers/rails_bpm/dashboard_controller.rb
module RailsBpm
  class DashboardController < RailsBpm::ApplicationController
  
    def index
    end

  end
end

app/controllers/rails_bpm/process_definitions_controller.rb
module RailsBpm
  class ProcessDefinitionsController < RailsBpm::ApplicationController

    def index
    end

    def create
    end

    def new
    end

    def edit
    end

    def show
    end

    def update
    end

    def destroy
    end

  end
end

app/controllers/rails_bpm/roles_controller.rb
module RailsBpm
  class RolesController < RailsBpm::ApplicationController

    def index
      @roles = Role.paginate(page: params[:page], per_page: 10)
    end

    def new
      @role = Role.new
      @users = RailsBpm.user_class.all
      @selected_users = @role.users
    end

    def edit
      @role = Role.find(params[:id])
      @users = RailsBpm.user_class.all
      @selected_users = @role.users
    end

    def create
      @role = Role.new(role_params[:role])
      users = params.permit(:users).reject { |u| u.empty? }
      @role.users = users.to_a
      @selected_users = @role.users
      if(@role.save)
        flash[:success] = "Created role '#{@role.name}'!"
        redirect_to action: :index
      else
        errors = extract_errors(@role)
        flash.now[:danger] = "Couldn't save your new role...<br />#{errors.join("<br />")}".html_safe
        render :new
      end
    end

    def update
      @role = Role.find(params[:id])
      @selected_users = @role.users
      if(@role.update(role_params[:role]))
        flash[:success] = "Updated '#{@role.name}'!"
        redirect_to action: :index
      else
        errors = extract_errors(@role)
        flash.now[:danger] = "Couldn't save your role...<br />#{errors.join("<br />")}".html_safe
        render :edit
      end
    end

    def destroy
      role = Role.find(params[:id])
      if(role.destroy)
        flash[:success] = "Role '#{role.name}' deleted."
        redirect_to action: :index
      else
        flash.now[:danger] = "Sorry...couldn't delete '#{@role.name}'."
        redirect_to action: :index
      end
    end

    def role_params
      params.permit(role: [:name, :description] )
    end

  end
end

app/controllers/rails_bpm/task_definitions_controller.rb
module RailsBpm
  class TaskDefinitionsController < RailsBpm::ApplicationController

    def index
    end

    def create
    end

    def new
    end

    def edit
    end

    def show
    end

    def update
    end

    def destroy
    end

  end
end

app/controllers/rails_bpm/users_controller.rb
require_dependency "rails_bpm/application_controller"

module RailsBpm
  class UsersController < ApplicationController

    def index
      @users = RailsBpm.user_class.paginate(page: params[:page], per_page: 10)
    end

    def edit
      @user = RailsBpm.user_class.find(params[:id])
      @user_roles = @user.bpm_roles
      @roles = RailsBpm::Role.all.order(:name)
    end

    def update
      user = RailsBpm.user_class.find(params[:id])
      user.rails_bpm_roles = RailsBpm::Role.find(params[:roles])
      if(user.save)
        flash[:success] = "Successfully updated!"
      else
        flash[:error] = "Something went wrong."
      end

      redirect_to action: :edit
    end

  end
end

app/helpers/rails_bpm/application_helper.rb
module RailsBpm
  module ApplicationHelper

    def active_controller_class(controller)
      params[:controller] == ("rails_bpm/" + controller) ? 'active' : ''
    end

    def user_display(user)
      user.send(RailsBpm.user_display_method)
    end

    def user_roles(user)
      rs = user.bpm_roles.map { |r| r.name }.sort_by { |n| n }.join(", ")
      return "None" if rs.size == 0
      rs.size > 50 ? (rs[0..50] + "...") : rs
    end

    def svg_icon(icon)
      ics = "icon-#{icon.to_s}"
      content_tag :svg, class: "icon #{ics}", viewBox: "0 0 1024 1024" do
        content_tag :use, { "xlink:href" => "##{ics}" } do
        end
      end
    end

    def paginator(collection)
      render partial: "rails_bpm/shared/paginator", locals: { collection: collection }
    end

    def resource_crumbs()
      c_name = params[:controller].gsub("rails_bpm/", "").capitalize.pluralize
      crumbs = [
        [ c_name, url_for( controller: params[:controller], action: :index ).html_safe, false ],
        [ params[:action].capitalize, nil, true ]
      ]
      render partial: "rails_bpm/shared/breadcrumbs", locals: { crumbs: crumbs }
    end

    def alert(msg, priority)
      # <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
      content_tag(:div, class: "alert alert-#{priority} alert-dismissible", role: "alert") do
        content_tag(:button, type: "button", class: "close", :'data-dismiss' => "alert", :'aria-label' => "Close") do
          content_tag(:span, :'aria-hidden' => true) do
            "&times;".html_safe
          end
        end +
        msg
      end
    end

    def user_select_options(users, selected = [])
      options_for_select(users.collect { |u| [ user_display(u), u.id ] }, selected.collect { |u| u.id })
    end

  end
end

app/helpers/rails_bpm/users_helper.rb
module RailsBpm
  module UsersHelper
  end
end

app/views/layouts/rails_bpm/_icons.html.erb
<svg display="none" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">
	<defs>

		<symbol id="icon-plus" viewBox="0 0 1024 1024">
			<title>plus</title>
			<path class="path1" d="M992 384h-352v-352c0-17.672-14.328-32-32-32h-192c-17.672 0-32 14.328-32 32v352h-352c-17.672 0-32 14.328-32 32v192c0 17.672 14.328 32 32 32h352v352c0 17.672 14.328 32 32 32h192c17.672 0 32-14.328 32-32v-352h352c17.672 0 32-14.328 32-32v-192c0-17.672-14.328-32-32-32z"></path>
		</symbol>

		<symbol id="icon-left-arrow" viewBox="0 0 1024 1024">
			<title>arrow-left</title>
			<path class="path1" d="M402.746 877.254l-320-320c-24.994-24.992-24.994-65.516 0-90.51l320-320c24.994-24.992 65.516-24.992 90.51 0 24.994 24.994 24.994 65.516 0 90.51l-210.746 210.746h613.49c35.346 0 64 28.654 64 64s-28.654 64-64 64h-613.49l210.746 210.746c12.496 12.496 18.744 28.876 18.744 45.254s-6.248 32.758-18.744 45.254c-24.994 24.994-65.516 24.994-90.51 0z"></path>
		</symbol>

		<symbol id="icon-trash" viewBox="0 0 1024 1024">
			<title>trash</title>
			<path class="path1" d="M959.36 218.208c-3.072-50.24-44.384-90.112-95.36-90.112h-96v-32.064c0-53.024-43.008-96-96-96h-320c-53.024 0-96 42.976-96 96v32.032h-96c-51.040 0-92.32 39.872-95.392 90.112h-0.608v69.856c0 35.328 28.672 64 64 64v0 544c0 70.688 57.312 128 128 128h512c70.688 0 128-57.312 128-128v-544c35.328 0 64-28.672 64-64v-69.824h-0.64zM320 96.064c0-17.696 14.304-32 32-32h320c17.696 0 32 14.304 32 32v32h-384v-32zM832 896.064c0 35.264-28.736 64-64 64h-512c-35.296 0-64-28.736-64-64v-544h640v544zM896 256.032v32h-768v-63.968c0-17.696 14.304-32 32-32h704c17.696 0 32 14.304 32 32v31.968zM288 896.192h64c17.696 0 32-14.304 32-32v-416c0-17.696-14.304-32-32-32h-64c-17.696 0-32 14.304-32 32v416c0 17.696 14.304 32 32 32zM288 448.16h64v416h-64v-416zM480 896.192h64c17.696 0 32-14.304 32-32v-416c0-17.696-14.304-32-32-32h-64c-17.696 0-32 14.304-32 32v416c0 17.696 14.304 32 32 32zM480 448.16h64v416h-64v-416zM672 896.192h64c17.696 0 32-14.304 32-32v-416c0-17.696-14.304-32-32-32h-64c-17.696 0-32 14.304-32 32v416c0 17.696 14.304 32 32 32zM672 448.16h64v416h-64v-416z"></path>
		</symbol>

	</defs>
</svg>

app/views/layouts/rails_bpm/application.html.erb
<!DOCTYPE html>
<html lang='en'>
  <head>

  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1">

  <title>Rails BPM</title>
  <%= stylesheet_link_tag    "rails_bpm/application", media: "all", 'data-turbolinks-track' => true %>

  <%= javascript_include_tag "rails_bpm/application", 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'https://js.stripe.com/v2/' %>

  <%= csrf_meta_tags %>

  <!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
  <!-- WARNING: Respond.js doesn't work if you view the page view fil:// -->
  <!--[if lt IE 9]>
    <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
    <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
  <![endif]-->

  </head>
  <body>
    <%= render partial: "layouts/rails_bpm/icons" %>

    <%= render partial: "rails_bpm/shared/header" %>

    <%= render partial: "rails_bpm/shared/alerts" %>

    <%= yield %>

  </body>
</html>

app/views/rails_bpm/dashboard/index.html.erb
<div class="container">

  <div class="starter-template">
    <h1>Dashboard Page</h1>
    <p class="lead">Show list of tasks currently assigned to me.</p>
  </div>

</div>

app/views/rails_bpm/process_definitions/index.html.erb
<div class="container">

  <div class="panel panel-default">
    <div class="panel-body"
      <h1>Process Definitions</h1>
    </div>
  </div>

</div>

app/views/rails_bpm/roles/edit.html.haml
.container.rails_bpm-content-container
  = resource_crumbs

  .index-head
    %h3.pull-left.index-title= @role.name
    = link_to("#{svg_icon(:trash)} <p>Delete</p>".html_safe, role_path(@role), method: :delete, class: "btn-link danger rails_bpm-list-add pull-right", data: { confirm: "Are you absolutely sure you want to delete #{@role.name}?" })

  .col-md-12.rails_bpm_index-tron-wrapper
    .jumbotron.rails_bpm_index-list
      .panel.panel-default
        = form_for(@role, html: { class: "edit-form" }) do |f|
          .form-group
            %label{ for: "name" } Name
            = f.text_field(:name, type: "text", class: "form-control", id: "name", placeholder: "Role name")
          .form-group
            %label{ for: "description" } Description
            = f.text_field(:description, type: "text", class: "form-control", id: "description", placeholder: "Role description")
          .form-group
            %label{ for: "users" } Users
            = f.select(:users, user_select_options(@users, @selected_users), {}, class: "form-control select2", multiple: true, id: "users", placeholder: "Users")
          = f.submit("Create", class: "btn btn-primary")

app/views/rails_bpm/roles/index.html.haml
.container.rails_bpm-content-container

  .index-head
    %h3.pull-left.index-title Roles

    %a.rails_bpm-list-add.btn.pull-right{ href: new_role_path }
      = svg_icon :plus
      %p Add a new role

  .col-md-12.rails_bpm_index-tron-wrapper#role-list
    .jumbotron.rails_bpm_index-list
      .panel.panel-default

        -# Headers
        .row.rails_bpm_index-list-headers
          .col-md-2.rails_bpm_index-list-header
            %h3
              %small Id
          .col-md-3.rails_bpm_index-list-header
            %h3
              %small Role
          .col-md-5.rails_bpm_index-list-header
            %h3
              %small Description

        -# List
        - @roles.each do |r|
          .row.rails_bpm_index-list-item
            %a{ href: edit_role_path(r) }
              .col-md-2= r.id
              .col-md-3= r.name
              .col-md-6= r.description
            .col-md-1= link_to("Delete", role_path(r), method: :delete, class: "btn-link danger", data: { confirm: "Are you absolutely sure you want to delete #{r.name}?" })

      = paginator(@roles)

app/views/rails_bpm/roles/new.html.haml
.container.rails_bpm-content-container
  = resource_crumbs

  .index-head
    %h3.pull-left.index-title New Role

  .col-md-12.rails_bpm_index-tron-wrapper
    .jumbotron.rails_bpm_index-list
      .panel.panel-default
        = form_for(@role, html: { class: "edit-form" }) do |f|
          .form-group
            %label{ for: "name" } Name
            = f.text_field(:name, type: "text", class: "form-control", id: "name", placeholder: "Role name")
          .form-group
            %label{ for: "description" } Description
            = f.text_field(:description, type: "text", class: "form-control", id: "description", placeholder: "Role description")
          .form-group
            %label{ for: "users" } Users
            = f.select(:users, user_select_options(@users, @selected_users), {}, class: "form-control select2", multiple: true, id: "users", placeholder: "Users")
          = f.submit("Create", class: "btn btn-primary")

app/views/rails_bpm/shared/_alerts.html.haml
- flash.each do |priority,msg|
  = alert(msg, priority)

app/views/rails_bpm/shared/_breadcrumbs.html.haml
%ol.breadcrumb
  - crumbs.each do |c|
    - if(c[2])
      %li{ class: "active" }= c[0]
    - else
      %li
        %a{ href: c[1] }=c[0]

app/views/rails_bpm/shared/_header.html.erb
<nav class="navbar navbar-inverse navbar-fixed-top">
  <div class="container">
    <div class="navbar-header">
      <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar" aria-expanded="false" aria-controls="navbar">
        <span class="sr-only">Toggle navigation</span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
      </button>
      <span class="navbar-brand"><%= RailsBpm.title %></span>
    </div>
    <div id="navbar" class="collapse navbar-collapse">
      <ul class="nav navbar-nav">
        <li class="<%= active_controller_class('dashboard') %>"><%= link_to "Dashboard", root_path %></li>
        <li class="<%= active_controller_class('process_definitions') %>"><%= link_to "Process Definitions", process_definitions_path %></li>
        <li class="<%= active_controller_class('adapter_settings') %>"><%= link_to "Adapter Settings", root_path %></li>
        <li class="<%= active_controller_class('roles') %>"><%= link_to "Roles", roles_path %></li>
        <li class="<%= active_controller_class('users') %>"><%= link_to "Users", users_path %></li>
      </ul>
    </div><!--/.nav-collapse -->
  </div>
</nav>

app/views/rails_bpm/shared/_paginator.html.haml
.paginator
  = will_paginate(collection, container: false)
  .page_info
    = page_entries_info(collection)

app/views/rails_bpm/users/edit.html.haml
.container.rails_bpm-content-container
  = resource_crumbs

  .index-head
    %h3.pull-left.index-title= user_display(@user)

  .col-md-12.rails_bpm_index-tron-wrapper
    .jumbotron.rails_bpm_index-list
      .panel.panel-default
        = form_for(@user, html: { class: "edit-form" }) do |f|
          = f.submit("Update", class: "btn btn-primary submit")
          -# Available roles
          - @roles.each do |r|
            .checkbox.col-sm-3.role-checkbox
              %label{ for: "box-#{r.id}" }
                = check_box_tag("roles[]", r.id, @user_roles.include?(r), id: "box-#{r.id}")
                = r.name

app/views/rails_bpm/users/index.html.haml
.container.rails_bpm-content-container

  .index-head
    %h3.pull-left.index-title Users

  .col-md-12.rails_bpm_index-tron-wrapper#user-list
    .jumbotron.rails_bpm_index-list
      .panel.panel-default

        -# Headers
        .row.rails_bpm_index-list-headers
          .col-md-6.rails_bpm_index-list-header
            %h3
              %small User
          .col-md-6.rails_bpm_index-list-header
            %h3
              %small Roles

        -# List
        - @users.each do |u|
          %a.row.rails_bpm_index-list-item{ href: edit_user_path(u) }
            .col-md-6= user_display(u)
            .col-md-6= user_roles(u)


      = paginator(@users)